
\chapter{Hardware Benchmark Protocol}\label{ap:comp_prot}
%todo

%\begin{landscape}
\section{Complete hardware definition}\label{ap:sec:hw_def}
The "{}RasPiCam"{} corrensponds to the Raspberri Pi Camera (B) with a field of view of 160 degrees.

\begin{table}[!htb]
    \centering
    \resizebox{\textwidth}{!}{
        \begin{tabular}[c]{|l|l|l|l|l|l|l|l|l|}
            \hline
            Model name & Computation & RAM & Electronics & Memory & Battery & Actuators & Sensors & Note \\ \hline
            %
            DB17 & \bigcell{l}{Raspberry Pi\\3B} & 1 GB & \bigcell{l}{DC Motor Hat,\\Servo/PWM Hat} & N/A & N/A & \bigcell{l}{2x Motor\\(Dagu yellow),\\LEDs} & RasPiCam & MIT \\ \hline
            DB18p1 & \bigcell{l}{Raspberry Pi\\3B+} & 1 GB & Hut v1.1 & \bigcell{l}{16GB, SD-Card\\SanDisk, ultra} & Bat\_v1 & \bigcell{l}{2x Motor\\(Dagu yellow),\\LEDs} & RasPiCam & current spec. \\ \hline
            DB18p2 & \bigcell{l}{Raspberry Pi\\3B+} & 1 GB & Hut v1.1 & \bigcell{l}{32GB, SD-Card\\SanDisk Micro SDHC} & Bat\_v1 & \bigcell{l}{2x Motor\\(Dagu yellow),\\LEDs} & RasPiCam & current spec. \\ \hline
            DB18p3 & \bigcell{l}{Raspberry Pi\\3B+} & 1 GB & Hut v1.1 & \bigcell{l}{32GB, SD-Card\\SanDisk Micro SDHC} & Bat\_v1 & \bigcell{l}{2x Motor\\(Dagu yellow),\\LEDs} & RasPiCam & current spec. \\ \hline
            DB18p4 & \bigcell{l}{Raspberry Pi\\3B+} & 1 GB & Hut v1.1 & \bigcell{l}{32GB, SD-Card\\SanDisk Micro SDHC} & Bat\_v1 & \bigcell{l}{2x Motor\\(Dagu yellow),\\LEDs} & RasPiCam & current spec. \\ \hline
            DB19 & \bigcell{l}{Raspberry Pi\\3B+} & 1 GB & Hut v2.0 & \bigcell{l}{32GB, SD-Card\\SanDisk Micro SDHC} & Bat\_v2 & \bigcell{l}{2x Motor\\(Dagu blue),\\LEDs} & \bigcell{l}{RasPiCam,\\wheel encoder} & tba \\ \hline
            DB20 & \bigcell{l}{Raspberry Pi\\4B} & 2 GB & Hut v2.0 & \bigcell{l}{32GB, SD-Card\\tba} & Bat\_v2 & \bigcell{l}{2x Motor\\(Dagu blue),\\screen,\\speaker,\\LEDs} & \bigcell{l}{RasPiCam,\\wheel encoder,\\IMU,\\IR-sensor,\\gyro,\\line sensor,\\}& tba \\ \hline
            DB21/DBv2 & \bigcell{l}{Raspberry Pi\\4B} & 2 GB & Hut v2.0 & \bigcell{l}{32GB, SD-Card\\tba} & Bat\_v2 & \bigcell{l}{1x Motor\\(Dagu blue),\\servo,\\screen,\\speaker,\\LEDs} & \bigcell{l}{RasPiCam,\\wheel encoder,\\IMU,\\IR-sensor,\\gyro,\\line sensor,\\steering servo} & tba, Ackermann \\ \hline
        \end{tabular}
    }
\end{table}
Please note that the \verb+DB19+, \verb+DB20+, \verb+DB21+ aren't released at the time this thesis was written.
%\end{landscape}

\section{Pinned Software: Docker Digests}\label{ap:sec:digests}
A collection of all Docker digests fixed during for the benchmark can be found here. For a repository of adjusted duckietown shell commands please visit.
\\\url{https://github.com/lujobi/duckietown-shell-commands-fixed-images/tree/benchmark} 

\paragraph{For master19}
\begin{itemize}
    \item   \lstinline|portainer/portainer:linux-arm@sha256:|\\
            \lstinline|7aa9d50dfebcc84a356c29ec8fb205a7d20b9f2ebbc265b992891c20283b50fd|
    \item   \lstinline|v2tec/watchtower:armhf-latest:|\\
            \lstinline|63abf3fc71a46b8fc46674342766d976e6a97d6c70d2560a0986ec63c1784812|
    \item   \lstinline|duckietown/rpi-simple-server:master18@sha256:|\\
            \lstinline|6b6787319cd87b413d5b0a8737f6127c719293c12936c94b5ea3a2d7fd62f6b5|
    \item   \lstinline|duckietown/rpi-health:master18@sha256:|\\
            \lstinline|c368e18f3fd804d2b801a6a650a8811f82cd92272a77838737527795aedd79f3|
    \item   \lstinline|duckietown/rpi-duckiebot-online:master18@sha256:|\\
            \lstinline|68e5d5b1d6677e8f0110b4f81bb1fb3d47d5658d8de8988108999b7cd8dce3e2|
    \item   \lstinline|duckietown/rpi-duckiebot-loader:master18@sha256:|\\
            \lstinline|986708fcac2f9051b17f51c02514279a42089e758b220311ac2de52aa5bad1ec|
    \item   \lstinline|duckietown/rpi-python-picamera:master18@sha256:|\\
            \lstinline|56e72af27a01611f2e5b693e87a6361db470c0aced17fa509e64328139713b8c|
    \item   \lstinline|duckietown/duckiebot-interface:master19@sha256:|\\
            \lstinline|4a64346a5dcd6dfb05dd45b90ed8aebd33b7eaae0410ef5337576268dd29203f|
    \item   \lstinline|duckietown/rpi-duckiebot-ros-picam:master18@sha256:|\\
            \lstinline|84945d3dfbdd0bae0b9158925f3c64cb4b197e2251f4f8ef40cbc9bd8921341d|
    \item   \lstinline|duckietown/rpi-duckiebot-web\_video\_server:master18@sha256:|\\
            \lstinline|14b7dee8e70a9fc3dd5b8cb584485282beb3dc7c094b84aa9ca5146a474c49ee|
    \item   \lstinline|duckietown/rpi-duckiebot-base:master19@sha256:|\\
            \lstinline|80f23a1835e6b3f9d2606aae54ce824dd13085e3e7491e87c7f0216797964b5c|
    \item   \lstinline|duckietown/rpi-duckiebot-web\_video\_server:master18@sha256:|\\
            \lstinline|14b7dee8e70a9fc3dd5b8cb584485282beb3dc7c094b84aa9ca5146a474c49ee|
    \item   \lstinline|duckietown/rpi-duckiebot-dashboard:master19@sha256:|\\
            \lstinline|duckietown/rpi-duckiebot-dashboard:master19|
    \item   \lstinline|duckietown/rosbridge-websocket:master19@sha256:|\\
            \lstinline|663eec480f5f375303f76389fb01cff2b8a4f1bc97b01817afaae45851e7ac8b|
    \item   \lstinline|duckietown/duckietown-swarm-rpi:latest@sha256:|\\
            \lstinline|817a270459b28fe211ba376c64bae846c170b84d265e5326ce7c6b97978a2946|
\end{itemize}

\paragraph{daffy}
\begin{itemize}
    \item   \lstinline|portainer/portainer@sha256:|\\
            \lstinline|7aa9d50dfebcc84a356c29ec8fb205a7d20b9f2ebbc265b992891c20283b50fd|
    \item   \lstinline|v2tec/watchtower@sha256:|\\
            \lstinline|63abf3fc71a46b8fc46674342766d976e6a97d6c70d2560a0986ec63c1784812|
    \item   \lstinline|duckietown/dt-duckiebot-dashboard@sha256:|\\
            \lstinline|247f74be1051c3097dcbbb06a09d9ecbc877a42a5fda40fb7c290731ed69a800|
    \item   \lstinline|duckietown/dt-device-loader@sha256:|\\
            \lstinline|82cdea83a565e531b7ad6cdddeccf0265d881e1461ad5e454bad567a45bf6cce|
    \item   \lstinline|duckietown/rpi-health@sha256:|\\
            \lstinline|c368e18f3fd804d2b801a6a650a8811f82cd92272a77838737527795aedd79f3|
    \item   \lstinline|duckietown/dt-device-online@sha256:|\\
            \lstinline|2fc13839c8e130b825b15b3a702c3b2775460a98eeb26ed7d3c4eb8fa771db17|
    \item   \lstinline|duckietown/dt-duckiebot-interface@sha256:|\\
            \lstinline|94a9defa553d1e238566a621e084c4b368e6a9b62053b02f0eef1d5685f9ea73|
    \item   \lstinline|duckietown/dt-car-interface@sha256:|\\
            \lstinline|e3db984157bf3a2b2d4ab7237536c17b37333711244a3206517daa187c143016|
    \item   \lstinline|duckietown/dt-rosbridge-websocket@sha256:|\\
            \lstinline|ae113368a58e0d3f52557a10794a8492645b05864d0f9ca151c48bd42c900a41|
    \item   \lstinline|duckietown/rpi-simple-server@sha256:|\\
            \lstinline|6b6787319cd87b413d5b0a8737f6127c719293c12936c94b5ea3a2d7fd62f6b5|
    \item   \lstinline|duckietown/rpi-duckiebot-ros-picam@sha256:|\\
            \lstinline|84945d3dfbdd0bae0b9158925f3c64cb4b197e2251f4f8ef40cbc9bd8921341d|
    \item   \lstinline|duckietown/rpi-duckiebot-web\_video\_server@sha256:|\\
            \lstinline|14b7dee8e70a9fc3dd5b8cb584485282beb3dc7c094b84aa9ca5146a474c49ee|
    \item   \lstinline|duckietown/dt-core:daffy@sha256:|\\
            \lstinline|4c7633c2041f5b7846be2346e0892c9f50987d2fd98d3479ec1a4cf378f52ee6|
    \item   \lstinline|calibration: duckietown/dt-core@sha256:|\\
            \lstinline|d72e8a8c3191c146ecc2a812bdd036aaf15076e6c1cb9467304e0e54f9a39a10|
    \item   \lstinline|duckietown/duckietown-swarm-rpi@sha256:|\\
            \lstinline|817a270459b28fe211ba376c64bae846c170b84d265e5326ce7c6b97978a2946|
\end{itemize}

\section{Benchmark Score weights}\label{ap:bm_score_weights}
This is how the current weights are set:
\begin{itemize}
    \item Health 
    \begin{itemize}
        \item \verb+status_tribool+, weight: 5
        \item \verb+ldn_latency+, weight: 2
        \item \verb+cpu_temp_c+, weight: 3
        \item \verb+throttling_bool+, weight: 10
    \end{itemize}
    \item Engineering
    \begin{itemize}
        \item \verb+sd_card_read_speed+, weight: 2
        \item \verb+sd_card_write_speed+, weight: 2
        \item \verb+cpu_temp_c+, weight: 3
        \item \verb+cpu_p+, weight: 3
        \item \verb+ram_p+, weight: 2
        \item \verb+swap_p+, weight: 1
    \end{itemize}
    \item Lane following:
    \begin{itemize}
        \item \verb+ldn_segments+, weight: 1
        \item \verb+ldn_latency+, weight: 3
        \item \verb+cpu_p+, weight: 0.5
        \item \verb+ram_p+, weight: 0.5
    \end{itemize}
    \item Container:
    \begin{itemize}
        \item \verb+nthreads+, weight: 1
        \item \verb+pcpu+, weight: 2,
    \end{itemize}
\end{itemize}
\cleardoublepage